package no.stud.bolts;

import java.util.Map;

import backtype.storm.task.OutputCollector;
import backtype.storm.task.TopologyContext;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseRichBolt;
import backtype.storm.tuple.Tuple;


/**
 * Dumps income stream in the black hole.
 */
public class BlackHoleBolt extends BaseRichBolt {
	OutputCollector _collector;
	Integer id;
	String name;


	/**
	 */
	public void cleanup() {
	}

	/**
	 * On create 
	 */
	public void prepare(Map stormConf, TopologyContext context, OutputCollector collector) {
		this._collector = collector;
		this.name = context.getThisComponentId();
		this.id = context.getThisTaskId();
	}

	@Override
	public void declareOutputFields(OutputFieldsDeclarer declarer) {}

	public void execute(Tuple input) {
	// yeah lets grab the string, but will we do anything with it nope.
	// so letting it up to the garbage collector to come claim it again.

	//	Standardtype
	// 		String content = input.getString(0);

	//	Working serialization
		double[] b = (double[]) input.getValue(0);
		if(b != null) if(b.length>0) {
			;
		}
		// Enable  
//	    _collector.ack(input);
	}

}
