package no.stud.bolts;

import java.util.Map;
import backtype.storm.task.TopologyContext;
import backtype.storm.topology.BasicOutputCollector;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseBasicBolt;
import backtype.storm.tuple.Tuple;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * This bolt was used as a experiment, before moving on to the usage of a binary file format.
 * It might be slightly dated and may not work out of the box.
 * 
 * Dumps strings followed of a newline to a CP-1252 (Windows 7) or UTF-8 format(Ubuntu Linux)
 */
public class FileDumpBolt extends BaseBasicBolt {

// 	Integer id;
// 	String name;
	File file;
	FileWriter fw;
	BufferedWriter bw;
	
	
	/**
	 */
	@Override
	public void cleanup() {
		try {
			bw.close();
			fw.close();
		} catch (IOException e) { e.printStackTrace(); }
	}

	/**
	 * On create 
	 */
	@Override
	public void prepare(Map stormConf, TopologyContext context) {
// 		this.name = context.getThisComponentId();
// 		this.id = context.getThisTaskId();
		
		try {
			File file = new File("/tmp/storm-output.txt");
			// if file doesnt exists, then create it
			if (!file.exists()) {
				file.createNewFile();
			} else {
				// TODO: shutdown 
				//throw new IllegalArgumentException("OutputFile already exist. Forcing a shutdown of topology.");
				
			}
			fw = new FileWriter(file.getAbsoluteFile()/*,"UTF-8"*/);
			bw = new BufferedWriter(fw/*new OutputStreamWriter(*//*fw*//*new FileOutputStream(path)*//*,"UTF-8")*/);
		} catch (IOException e) { e.printStackTrace(); }
	}

	@Override
	public void declareOutputFields(OutputFieldsDeclarer declarer) {}


	@Override
	public void execute(Tuple input, BasicOutputCollector collector) {
		String content = input.getString(0);
		try {
			bw.write(content+"\n");
			bw.flush();		// Simply for avoiding write of hafe lines on shutdown. (is not hurting performance have a look at time execute on bolt)
		} catch (IOException e) { e.printStackTrace(); }
	}
}
