package no.stud.spouts.datagenerators;


public class UniformGenerator extends DistributionGenerator{


	public UniformGenerator( int nMaxValue, int dimensions)
	{
        super( nMaxValue,  dimensions);
	}


	public double[] nextPoint ()
	{
		double dims[] = new double[dimensions];
		for (int s=0;s<dimensions;s++)
		{
			dims [s] = MAX_VALUE*uniform.nextDouble();             //must be enabled
			while ((dims[s]>MAX_VALUE)||(dims[s]<0))			// første testes fordi en double kan lett bli større en en int. andre del må ha noe med konverteringa fra dobbel å gjøre så da kan sikkert de 52 bitsa overflowes.
				dims [s] = MAX_VALUE*uniform.nextDouble();	// can this be close to psedu random when loop is active?
		}	 
		return dims;
	}

}
